﻿Version=6.90
NumberOfForms=0
NumberOfObjects=0
Sub designer
end sub
@EndOfDesignText@
'**************************************************************************************
'*                               EXCEL WRITER V 1.1                                   *
'*                                                                                    *
'*                       Created by Paulo Gomes aka CABLEGUY                          *
'*								    Jully, 2010                                       *
'*                                                                                    *
'* This is a more functional Module that enables the Basic4PPc Programers To generate *
'* .xls files. Both basic AND advanced cell formating is possible. Creating atractive *
'* repports in Excel, with nice formated Fonts, colored Cells with OR without Borders.*
'* Even placing Formulas, that will be calculated on Excel WorkBook Load.             *
'*                                                                                    *
'* I hope you enjoy AND find this usefull. As always, NO Waranty is given at any level*
'* AND If you have any comments, features requests OR Bug repports, please visit us at*
'*                                                                                    *
'*                               WWW.BASIC4PPC.COM\FORUM                              *
'**************************************************************************************

Sub Globals
	a = Chr(34)
	e = CRLF
	BookName = ""
	Dim Header(8) As String
	Dim DStyle(8) As String
	RIndex = ""
End Sub

Public Sub CreateWorkBook(WorkBookName)
	BookName = WorkBookName
	AddArrayList("Styles")
	AddArrayList("WorkSheets")
End Sub
	
Public Sub SetTitle(Title) 
	Header(1) = "<Title>" & Title & "</Title>"
End Sub
	
Public Sub SetSubject(Subject) 
	Header(2) = "<Subject>" & Subject & "</Subject>"
End Sub
	
Public Sub SetAuthor(Author)
	Header(3) = "<Author>" & Author & "</Author>"	
End Sub
	
Public Sub SetManager(Manager) 
	Header(5) = "<Manager>" & Manager & "</Manager>"
End Sub
	
Public Sub SetCompany(Company) 
	Header(6) = "<Company>" & Company & "</Company>"
End Sub

Public Sub CreateStyle(StyleName)
	ArrayList("Styles").Add(StyleName)
	AddArrayList(StyleName)
	AddArrayList(StyleName & "Alignment")
	AddArrayList(StyleName & "Borders")
	AddArrayList(StyleName & "Font")
	AddArrayList(StyleName & "Interior")
	AddArrayList(StyleName & "NumberFormat")'
	Control(StyleName,ArrayList).Add("<Style ss:ID=" & a & StyleName & a & ">")
	Control(StyleName,ArrayList).Add("</Style>")
End Sub

Public Sub SetStyleAlignment(StyleName,Horizontal,Vertical)
	r = "<Alignment ss:Horizontal=" & a & Horizontal & a & " ss:Vertical=" & a & Vertical & a & "/>"
	ArrayList(StyleName & "Alignment").add(r)
End Sub

Public Sub SetStyleBorders(StyleName,Position,LineStyle,Weight,LineColor)
	r = "<Border ss:Position=" & a & Position & a & " ss:LineStyle=" & a & LineStyle & a & " ss:Weight=" & a & Weight & a & " ss:Color=" & a & LineColor & a & "/>"
	ArrayList(StyleName & "Borders").add(r)
End Sub
	
Public Sub SetStyleFont(StyleName,FontName,FontSize,FontColor,Bold,Italic,Underlined)
	r = "<Font ss:FontName=" & a & FontName & a & " ss:Size=" & a & FontSize & a 
	r = r & " ss:Color=" & a & FontColor & a & " ss:Bold=" & a & Bold & a & " ss:Italic="
	r = r & a & Italic & a & " ss:Underline=" & a & Underlined & a & "/>"
	ArrayList(StyleName & "Font").add(r)
End Sub
	
Public Sub SetStyleInterior(StyleName,Color,Pattern)
	r = "<Interior ss:Color=" & a & Color & a & " ss:Pattern=" & a & Pattern & a & "/>"
	ArrayList(StyleName & "Interior").add(r)
End Sub

Public Sub SetStyleNumberFormat(StyleName,NumberFormat)
	r = "<NumberFormat ss:Format=" & a & NumberFormat & a & "/>"
	ArrayList(StyleName & "NumberFormat").add(r)
End Sub

Public Sub AddWorkSheet(WorkSheetName)
	ArrayList("WorkSheets").Add(WorkSheetName)
	AddArrayList(WorkSheetName)
	AddArrayList(WorkSheetName & "Row")
	AddArrayList(WorkSheetName & "Column")
	r = "<Worksheet ss:Name=" & a & WorkSheetName & a & ">"
	ArrayList(WorkSheetName).Add(r)
	r = "<Table x:FullColumns=" & a & "1" & a & " x:FullRows=" & a & 1 & a & ">"
	ArrayList(WorkSheetName).Add(r)
End Sub
	

	Public Sub FormatColumn(WorkSheetName,ColIndex,Span,AutoFit,Width,Hidden)
		r="<Column "
		If ColIndex="" Then
			r = r
		Else
			r = r & " ss:Index=" & a & ColIndex & a
		End If
		If Span="" Then
			r = r
		Else
			r = r & " ss:Span=" & a & Span & a
		End If
		If AutoFit="" Then
			r = r
		Else
			r = r & " ss:AutoFitWidth=" & a & AutoFit & a
		End If
		If Width="" Then
			r = r
		Else
			r = r & " ss:Width=" & a & Width & a
		End If
		If Hidden="" Then
			r = r
		Else
			r = r & " ss:Hidden=" & a & Hidden & a
		End If
		r = r & "/>"
		ArrayList(WorkSheetName & "Column").Add(r)
	End Sub
	
	Public Sub SelectRow(WorkSheetName,RowIndex,RowHeight,AutoFitHeight,Hidden)
		RIndex=RowIndex
		AddArrayList(WorkSheetName & "Row" & RowIndex)
		
		r = "<Row ss:Index=" & a & RowIndex & a
		
		If AutoFitHeight="" Then
			r = r
		Else
			r = r & " ss:AutoFitHeight=" & a & AutoFitHeight & a
		End If
		If RowHeight="" Then
			r = r
		Else
			r = r & " ss:Height=" & a & RowHeight & a
		End If
		If Hidden="" Then
			r = r
		Else
			r = r & " ss:Hidden=" & a & Hidden & a
		End If
		r = r & ">"
		ArrayList(WorkSheetName & "Row").Add(RowIndex)
		ArrayList(WorkSheetName & "Row" & RowIndex).Add(r)
End Sub
	
	Public Sub InsertStringToCell(WorkSheetName,StyleName,Value,ColIndex)
		r="<Cell"
		If ColIndex="" Then
			r=r 
		Else
			r=r & " ss:Index=" & a & ColIndex & a
		End If
		
		If StyleName="" Then
		r=r & ">"
		Else
		r=r & " ss:StyleID=" & a & StyleName & a & ">"
		End If
		
		ArrayList(WorkSheetName & "Row" & RIndex).Add(r)
		r=""
		r="<Data ss:Type=" & a & "String" & a & ">" & Value & "</Data>"
		Control(WorkSheetName & "Row" & RIndex,ArrayList).Add(r)
		r="</Cell>"
		ArrayList(WorkSheetName & "Row" & RIndex).Add(r)
		
	End Sub

	
	Public Sub CreateXlsFile
		#Region WorkBook
		'This creates an empty xls file-shell
		FileOpen(x,AppPath & "\" & BookName & ".xls",cWrite)
		
		'This Creates the file Header
		CreateHeader
		
		'This sets the Created date for the file
		SetCreatedDateTime

		'This cicles trough the Header Array to save the initial basic info for the xls file
		For m=0 To 7
			w=Header(m)
			If w<>"" Then
				FileWrite(x,w)
			End If
		Next
#End Region
'
#Region Styles	
'This Adds all the created Styles
	FileWrite(x,"<Styles>")
'	'This is the default style
	CreateDefaultStyle
	For m=0 To 7
		w=DStyle(m)
		FileWrite(x,w)
	Next
	'These are the new styles
	For m=0 To ArrayList("Styles").Count-1 ' The styles list
		FileWrite(x,ArrayList(ArrayList("Styles").Item(m)).Item(0))
		'Alignments
		If ArrayList(ArrayList("Styles").Item(m)&"Alignment").Count>0 Then
		FileWrite(x,ArrayList(ArrayList("Styles").Item(m)&"Alignment").Item(0))
		End If
		'Borders
		If ArrayList(ArrayList("Styles").Item(m)&"Borders").Count>0 Then
		FileWrite(x,"<Borders>")
			For n=0 To ArrayList(ArrayList("Styles").Item(m)&"Borders").Count-1
				FileWrite(x,ArrayList(ArrayList("Styles").Item(m)&"Borders").Item(n))
			Next
		FileWrite(x,"</Borders>")
		End If
		'Font
		If ArrayList(ArrayList("Styles").Item(m)&"Font").Count>0 Then
			FileWrite(x,ArrayList(ArrayList("Styles").Item(m)&"Font").Item(0))
		End If
		'Interior
		If ArrayList(ArrayList("Styles").Item(m)&"Interior").Count>0 Then
			FileWrite(x,ArrayList(ArrayList("Styles").Item(m)&"Interior").Item(0))
		End If
		'NumberFormat
		If ArrayList(ArrayList("Styles").Item(m)&"NumberFormat").Count>0 Then
			FileWrite(x,ArrayList(ArrayList("Styles").Item(m)&"NumberFormat").Item(0))
		End If
		FileWrite(x,"</Style>")
	Next
'This Closes the Styles Tag
	FileWrite(x,"</Styles>")
#End Region
#Region Worksheets
	For m=0 To ArrayList("WorkSheets").Count-1 ' The Sheets list
		FileWrite(x,ArrayList(ArrayList("WorkSheets").Item(m)).Item(0))
		FileWrite(x,ArrayList(ArrayList("WorkSheets").Item(m)).Item(1))
		'Columns
		If ArrayList(ArrayList("WorkSheets").Item(m)&"Column").Count>0 Then
			For n=0 To ArrayList(ArrayList("WorkSheets").Item(m)&"Column").Count-1
				FileWrite(x,ArrayList(ArrayList("WorkSheets").Item(m)&"Column").Item(n))
			Next
		End If
		'InsertData
		If ArrayList(ArrayList("WorkSheets").Item(m)&"Row").Count>0 Then
			For n=0 To ArrayList(ArrayList("WorkSheets").Item(m)&"Row").Count-1
				For h=0 To ArrayList(ArrayList("WorkSheets").Item(m)&"Row" & ArrayList(ArrayList("WorkSheets").Item(m)&"Row").Item(n)).Count-1
					FileWrite(x,ArrayList(ArrayList("WorkSheets").Item(m)&"Row" & ArrayList(ArrayList("WorkSheets").Item(m)&"Row").Item(n)).Item(h))
				Next
				FileWrite(x,"</Row>")
			Next
		End If
		FileWrite(x,"</Table>")
'
'		'Close worksheet
		FileWrite(x,"</Worksheet>")
'		
	Next
	'Close the WoekBook
	FileWrite(x,"</Workbook>")
#End Region
	FileClose(x)
	
	
End Sub



Sub CreateHeader

	Header(0) = "<?xml version=" & a & "1.0" & a & "?>" & e
	Header(0) = Header(0) & "<?mso-application progid=" & a & "Excel.Sheet" & a & "?>" & e
	Header(0) = Header(0) & "<Workbook xmlns=" & a & "urn:schemas-microsoft-com:office:spreadsheet" & a & e
	Header(0) = Header(0) & "xmlns:o=" & a & "urn:schemas-microsoft-com:office:office" & a & e
	Header(0) = Header(0) & "xmlns:x=" & a & "urn:schemas-microsoft-com:office:excel" & a & e
	Header(0) = Header(0) & "xmlns:ss=" & a & "urn:schemas-microsoft-com:office:spreadsheet" & a & e
	Header(0) = Header(0) & "xmlns:html=" & a & "http://www.w3.org/TR/REC-html40" & a & ">" & e
	Header(0) = Header(0) & "<DocumentProperties xmlns=" & a & "urn:schemas-microsoft-com:office:office" & a & ">"
	
	Header(7) = "</DocumentProperties>" & e
	Header(7) = Header(7) & "<ExcelWorkbook xmlns=" & a & "urn:schemas-microsoft-com:office:excel" & a & ">" & e
	Header(7) = Header(7) & "<WindowHeight>9120</WindowHeight>" & e
	Header(7) = Header(7) & "<WindowWidth>15135</WindowWidth>" & e
	Header(7) = Header(7) & "<WindowTopX>120</WindowTopX>" & e
	Header(7) = Header(7) & "<WindowTopY>120</WindowTopY>" & e
	Header(7) = Header(7) & "<AcceptLabelsInFormulas/>" & e
	Header(7) = Header(7) & "<ProtectStructure>False</ProtectStructure>" & e
	Header(7) = Header(7) & "<ProtectWindows>False</ProtectWindows>" & e
	Header(7) = Header(7) & "</ExcelWorkbook>"

End Sub

Sub SetCreatedDateTime

	DateFormat("yyyy-mm-dd")
	TimeFormat("HH:mm:ss")
	Header(4) = "<Created>" & Date(Now) & "T" & Time(Now) & "Z</Created>"
End Sub

Sub CreateDefaultStyle
	DStyle(0) = "<Style ss:ID=" & a & "Default" & a & " ss:Name=" & a & "Normal" & a & ">"
	DStyle(1) = "<Alignment ss:Vertical=" & a & "Bottom" & a & "/>"
	DStyle(2) = "<Borders/>"
	DStyle(3) = "<Font/>"
	DStyle(4) = "<Interior/>"
	DStyle(5) = "<NumberFormat/>"
	DStyle(6) = "<Protection/>"
	DStyle(7) = "</Style>"
End Sub



